/* Sistemas Integrados TEKNISA

   Nome: 0002_FASSTPO_FATURA_CUSTOMIZACAO.SQL

   Descrio:
   Procedimento para Faturamento de Customizaes

   Criao:
   20/10/2006 - Fernando Lins Araujo Pinto

*/
CREATE OR REPLACE PROCEDURE FATURA_CUSTOMIZACAO(
  P_CDEMPRESA     IN APURFATUFAS.CDEMPRESA%TYPE,
  P_CLIENTE       IN CLIENTE.CDCLIENTE%TYPE,
  P_NRSOLISERV    IN SOLISERV.NRSOLISERV%TYPE,
  P_CDOPERAPUR    IN APURFATUFAS.CDOPERAPUR%TYPE,
  P_DTMENSPEDC    IN MENSLINPCLIE.DTMENSPEDC%TYPE)
AS
  V_INVOICE     NUMBER;
  V_NRINVOICE   VARCHAR2(10);
  V_CDPAIS      VARCHAR2(4);
  V_CODPRODUTO  VARCHAR2(10);
  V_PRXAPURACAO VARCHAR2(20);
  V_GRAVA_EMP   VARCHAR2(3);
BEGIN
  SELECT MAX(CDPROFATSOLI)
  INTO V_CODPRODUTO
  FROM PAR_GERAL_FAS;
  --
  FOR CUR_TOTAL IN (SELECT  PA.VRPARCSOLI, SO.NRSOLISERV, SO.CDFILIAL,  SO.CDCLIENTE, PA.NRPARCSOLI, SO.DSREFESOLI, E.CDEMPRESA
                    FROM    SOLISERV SO, PARCSOLISERV PA, EMPRESA E, FILIAL F, CLIENTE L 
                    WHERE   PA.DTPARCSOLI  <= TO_DATE(P_DTMENSPEDC,'DD/MM/YYYY')                         	AND
			    PA.NRAPURFATFAS IS NULL                                                             AND
                            SO. NRSOLISERV (+) = PA.NRSOLISERV                                          	AND
                            F.CDFILIAL      = SO.CDFILIAL                                                 	AND
                            SO.CDCLIENTE    = L.CDCLIENTE                                                	AND
			    F.CDEMPRESA     = E.CDEMPRESA							AND
                            ((INSTR(P_CLIENTE,  SO.CDCLIENTE)>0) OR (P_CLIENTE   = 'C'))                 	AND
                            ((INSTR(P_CDEMPRESA,E.CDEMPRESA)>0) OR (P_CDEMPRESA = 'E'))				AND
                            ((INSTR(P_NRSOLISERV,SO.NRSOLISERV)>0) OR (P_NRSOLISERV = 'S'))
 		    ORDER BY PA.VRPARCSOLI)LOOP
      --
      SELECT MAX(F.CDEMPRESA)
      INTO   V_GRAVA_EMP
      FROM   FILIAL F
      WHERE  F.CDEMPRESA = CUR_TOTAL.CDEMPRESA;
      --
      SELECT MAX(E.CDPAIS)
      INTO   V_CDPAIS
      FROM   CLIENTE C, ENDECLIE E
      WHERE  (C.CDCLIENTE = E.CDCLIENTE) AND (E.IDTPENDECLIE = 'P') AND (C.CDCLIENTE = CUR_TOTAL.CDCLIENTE);
      --
      IF (V_CDPAIS <> '0055') AND (NOT(V_CDPAIS IS NULL)) THEN
          --
          SELECT MAX(TO_NUMBER(NRINVOICE))
          INTO   V_INVOICE
          FROM   INVOICE I, CLIENTE C
          WHERE  (I.CDCLIENTE = C.CDCLIENTE) AND (I.CDCLIENTE = CUR_TOTAL.CDCLIENTE);
          --
          IF V_INVOICE IS NULL THEN
              V_INVOICE := 1;
          ELSE
              V_INVOICE := V_INVOICE + 1;
          END IF;
          --
          V_NRINVOICE := TO_CHAR(V_INVOICE);
          V_NRINVOICE := LPAD(V_NRINVOICE,10,'0');
          --
          INSERT INTO INVOICE (
              CDFILIAL,
              NRINVOICE,
              CDEMPRESA,
              CDCLIENTE,
              CDTPBAIXAREC,
              CDTPINDICE,
              IDPERVALOR,
              CDINDICE,
              CDFILIALNF,
              NRLANCTONF,
              DTINVOICE,
              DTVENINVOICE,
              DSLOCAEMBARQ,
              IDGERNFINVOI,
              DTRECINVOICE,
              VRPEACRINVOI
          ) VALUES (
              CUR_TOTAL.CDFILIAL,
              V_NRINVOICE,
              V_GRAVA_EMP,
              CUR_TOTAL.CDCLIENTE,
              (SELECT CDTPBAIXAREC FROM TIPOBAIXAREC WHERE ROWNUM = 1),
              (SELECT CDTPINDICE   FROM CLIENTE C    WHERE (C.CDCLIENTE = CUR_TOTAL.CDCLIENTE) AND (ROWNUM = 1)),
              (SELECT IDPERVALOR   FROM CLIENTE C    WHERE (C.CDCLIENTE = CUR_TOTAL.CDCLIENTE) AND (ROWNUM = 1)),
              (SELECT CDINDICE     FROM CLIENTE C    WHERE (C.CDCLIENTE = CUR_TOTAL.CDCLIENTE) AND (ROWNUM = 1)),
              NULL,
              NULL,
              (SELECT TO_DATE(SYSDATE) FROM DUAL),
              P_DTMENSPEDC,
              NULL,
              'N',
              NULL,
              NULL
          );
          --
          INSERT INTO ITEMINVOICE (
              CDFILIAL,
              NRINVOICE,
              NRSEQITINVOI,
              CDPRODUTO,
              VRUNITEINVOI,
              DSEMISSINVOI,
              CDTIPOSERV
          ) VALUES (
              CUR_TOTAL.CDFILIAL,
              V_NRINVOICE,
              1,
              V_CODPRODUTO,
              CUR_TOTAL.VRPARCSOLI,
              NULL,
              NULL
          );
      ELSE
          V_NRINVOICE := NULL;
      END IF;
      --
      IF NOT(CUR_TOTAL.VRPARCSOLI IS NULL) AND (CUR_TOTAL.VRPARCSOLI>0) THEN
          --
          NOVO_CODIGO('APURFATUFAS',V_PRXAPURACAO);
          --
          INSERT INTO APURFATUFAS (
              CDFILIAL,
              CDCLIENTE,
              NRAPURFATFAS,
              DTAPURFATFAS,
              VRTOTAFATFAS,
              DSEMISSPRONF,
              CDOPERAPUR,
              CDEMPRESA,
              CDTIPOSERV,
              CDPRODUTO,
              NRLANCTONF,
              NRINVOICE,
              IDAPURFATFAS,
 	      IDSTAPFATFAS,
	      IDCOMIFATFAS,
              DSBOLEFATFAS
          ) VALUES (
              CUR_TOTAL.CDFILIAL,
              CUR_TOTAL.CDCLIENTE,
              SUBSTR(V_PRXAPURACAO,11,10),
              (SELECT TO_DATE(SYSDATE) FROM DUAL),
              CUR_TOTAL.VRPARCSOLI,
              ('Customizao: '||CUR_TOTAL.DSREFESOLI ||' - Solicitao: '|| CUR_TOTAL.NRSOLISERV ||' - Parcela: '|| CUR_TOTAL.NRPARCSOLI),
              P_CDOPERAPUR,
              V_GRAVA_EMP,
              NULL,
              V_CODPRODUTO,
              NULL,
              V_NRINVOICE,
              '3',
	      'P',
              'N',
              (SELECT DSBOLETCLIE FROM PARCLIEFAS WHERE CDCLIENTE = CUR_TOTAL.CDCLIENTE AND IDTPFATUCLIE = '1')
          );
          --
          UPDATE  PARCSOLISERV
          SET     NRAPURFATFAS  = SUBSTR(V_PRXAPURACAO,11,10)
          WHERE   (CDFILIAL = CUR_TOTAL.CDFILIAL)          AND
		  (NRAPURFATFAS IS NULL)                   AND
 		  (NRSOLISERV = CUR_TOTAL.NRSOLISERV)    AND
 		  (NRPARCSOLI = CUR_TOTAL.NRPARCSOLI);
      END IF;
  END LOOP;
  -- TRANSAO EXPLCITA
  COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('FATURA_CUSTOMIZACAO','4.11.026'); END;
/

