<?php

namespace Teknisa\Model\Teknisa\Repositories;

use Teknisa\Model\Traits\TQuery;

class SlaclienteAlert extends \Doctrine\ORM\EntityRepository {

    use TQuery;

    /**
     * @param $cdcliente
     * @param $cdgrupfase
     * @param $cdassunto
     * @param $cdcomplexid
     * @return array
     */
    public function findSlaclienteAlert($cdcliente, $cdgrupfase, $cdassunto, $cdcomplexid)
    {
        $query = <<<SQL
            SELECT SA.ID, SA.ID_RESP_PROD_ESTRUT, SA.STRUCTURE_TYPE_ID, SA.QTHORASALERT, SA.IDANTESDEPOIS, 
                   SA.CDCLIENTE, SA.CDGRUPFASE, SA.CDASSUNTO, SA.CDCOMPLEXID,
                   DECODE(ID_RESP_PROD_ESTRUT, 'E', 'Responsável Estrutura', 'P', 'Gerente de Produto') AS LABEL_RESP_PROD_ESTRUT,
                   ST.LABEL AS STRUCTURE_TYPE_LABEL,
                   DECODE(SA.IDANTESDEPOIS, 'A', 'Antes', 'D', 'Depois') AS IDANTESDEPOIS_LABEL
              FROM SLACLIENTE_ALERT SA
         LEFT JOIN STRUCTURE_TYPE ST ON ST.ID = SA.STRUCTURE_TYPE_ID
             WHERE SA.CDCLIENTE = :CDCLIENTE
               AND SA.CDGRUPFASE = :CDGRUPFASE
               AND SA.CDASSUNTO = :CDASSUNTO
               AND SA.CDCOMPLEXID = :CDCOMPLEXID
SQL;
        $params = array(
            'CDCLIENTE' => $cdcliente,
            'CDGRUPFASE' => $cdgrupfase,
            'CDASSUNTO' => $cdassunto,
            'CDCOMPLEXID' => $cdcomplexid,
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->getEntityManager(), $query, $params);
    }

}
