function PopupController($scope, ScreenService, templateManager, eventEngine, $rootScope) {
	var self = this;

	self.onOpenPopup = function(event, widget, deferred) {
		$scope.widget = widget;
		$rootScope.popupOpen = true;
		if (widget.popupNoBlock) {
			$(document).on('mousedown', self._documentMouseDown);
			$(document).on('touchstart', self._documentMouseDown);
		}
		if (deferred) {
			deferred.resolve();
		}
	};

	$scope.$on('openPopup', self.onOpenPopup);

	this._documentMouseDown = function(e) {
		if ($(e.target).closest('.popup-container').length === 0 && $('.popup-container').is(':visible')) {
			$rootScope.$apply(function() {
				ScreenService.closePopup();
			});
			$(document).off('mousedown', this._documentMouseDown);
			$(document).off('touchstart', this._documentMouseDown);
		}
	};
	$scope.$on('closePopup', function(e) {
		$(document).off('mousedown', this._documentMouseDown);
		$(document).off('touchstart', this._documentMouseDown);
	});
	$scope.$on('changeContainer', function(e, widget) {
		ScreenService.closePopup();
	});

	$scope.closePopup = function() {
		ScreenService.closePopup();
	};

	$scope.actionClick = Util.buildDebounceMethod(function(action, widget, row) {
		// copia do ZeedhiControler.actionClick... refatorar// there is no problem here
		if (!action.aclReadOnly && !action.readOnly) {
			if (row) {
				widget.currentRow = row;
			}
			$scope.currentWidget = widget;
			templateManager.currentWidget = widget;
			var events = action.events;
			if (events) {
				eventEngine.bindEvents(action, events, function() {
					return widget.dataSource;
				}, function() {
					return widget.currentRow;
				}, function() {
					return widget.selectedRow;
				});
			}
			action.click();
		}
	}, 300, true);

	$scope.getIconClass = function(action, widget) {
		var classes = '';
		if (action.icon) {
			classes = action.icon;
			if (widget.popupNoBlock) {
				classes += ' icon-white';
			} else {
				classes += ' color-main';
			}
		}
		return classes;
	};
	
	$scope.getModalSize = function(widget) {
		var addPx = function(value) {
		  if (typeof value === 'number' || (typeof value === 'string' && !isNaN(value))) {
		    return value + 'px';
		  }
		
		  return value;
		};

		if (widget && widget.showAsModal) {
			var result = '';
			if (widget.width) result += 'width: ' + addPx(widget.width) + '; max-width: none;';
			if (widget.height) result += 'height: ' + addPx(widget.height);
			return result;
		} else {
			return '';
		}
	};
}